clear all; clc;

b=func_model_symb; % original non-linear model
a=func_lin_model_symb; %linearising the model to obtain A, B, C and D 

%% Non-linear model which can be used for parameter eatimation
function model_symb = func_model_symb
syms X1
syms X2

syms u
syms z

syms k
syms Kv
syms Kp
syms A
syms rho
syms g
syms G

%State Equation:
f_X1 = Kp/A*u-1/A*k*z*X2*(rho*g*X1/G);
f_X2 = 0;

model_symb.f_X1 = f_X1;
model_symb.f_X2 = f_X2;

end

%% Symbolic Linearisation of the non-linear model
function lin_model_symb = func_lin_model_symb

syms X1
syms X2

syms u
syms z

syms k
syms Kv
syms Kp
syms A
syms rho
syms g
syms G


%State Equation:
f_X1 = Kp/A*u-1/A*k*z*X2*(rho*g*X1/G);
f_X2 = 0;


A_cont_symb = jacobian([f_X1;f_X2],[X1;X2]);
B_cont_symb = jacobian([f_X1;f_X2],[u]);
C_cont_symb = [1 0];
D_cont_symb = [0];

lin_model_symb.A_cont_symb = A_cont_symb;
lin_model_symb.B_cont_symb = B_cont_symb;
lin_model_symb.C_cont_symb = C_cont_symb;
lin_model_symb.D_cont_symb = D_cont_symb;

end
